cWhite = color.new(255, 255, 255);
cBlack = color.new(0, 0, 0);

dofile("vars.tables.lua");
dofile("vars.global.lua");
dofile("functions.visual.lua");
dofile("functions.ui.lua");
dofile("functions.game.lua");
dofile("assets/system/puzzles.lua");

Init();
LoadPuzzle(puzzles[currentpuzzle]);
DrawBar();
tiles = CountTiles();
moves = CountMoves();
DrawSidebar();

screen.update();

local zoomed = 0;
local zoomout = 0;

while true do

	if control.read() == 1 then
		
		if control.isButton() == 1 then
			if button.home() == 1 and button.click() == 1 then
				if zoomed == 0 then
					if DlgYN() == true then break; end;
				else
					zoomed = 0;
					DrawGame(zoomed);
					DrawSidebar();
				end;
			end;
		end;
		
		if control.isTouch() == 1 then
			if touch.click() == 1 then
				TX, TY = touch.pos();
				zoomout = InRect(300, 0, 100, 30, TX, TY);
				
				if TX < 290 + 110 * zoomed and zoomout == false then
					if zoomed == 1 then SelectTile(); game_untouched = false; end;
					
					zoomed = 1;
					
					DrawGame(zoomed);
				
					if selected1 > -1 and selected2 > -1 then
						EvaluateTiles();
						tiles = CountTiles();
						moves = CountMoves();
						zoomed = 0;
					end;
				else
					if zoomout == true then zoomed = 0; end;
				end;
				
				if zoomed == 0 then	DrawSidebar(); end;
				
				if tiles == 0 then GameEnd(true);
				elseif moves == 0 then GameEnd(false); end;
			end;
		end;
		
	end;
	
	DrawBar();

	screen.update();
	os.sleep(2);
	
	if gameend == true then break; end;
	
end;
